# ncert_learn

**ncert_learn** is a comprehensive Python module designed to support NCERT Class 12 Computer Science students. It offers a wide range of utility functions across various topics, including Python programming, MySQL database interactions, mathematical operations, data structures, system utilities, and more.

## Key Features

### **Mathematical Functions**
- Prime number check
- Armstrong, Strong, Niven, Palindrome checks
- Fibonacci numbers, even/odd checks, and more

### **Data Structures**
- Stack operations using lists and dictionaries (push, pop, peek, display)

### **Geometric Calculations**
- Area calculations for circles, rectangles, squares, polygons, and triangles

### **Number Conversions**
- Convert integers to binary, octal, hexadecimal, and vice versa

### **MySQL Operations**
- Connect to MySQL, manage databases and tables, execute queries

### **Sorting Algorithms**
- Implementations of Bubble Sort and Insertion Sort

### **File Handling**
- Read, write, and manage text, CSV, and binary files
- File operations like copying, reading specific lines, and clearing contents

### **System Utilities**
- Fetch information about the operating system, processor, network connectivity, and Python interpreter

### **Package Management**
- Install and manage Python libraries, including bulk installation from a list

### **Time Management**
- Access current time, process time, monotonic time, and thread time

### **XAMPP Utilities**
- Start/stop XAMPP MySQL and Apache, check PHPMyAdmin access

### **Zip File Handling**
- Handle ZIP files (list contents, extract, add files)

## New Features in Version 3.0.2
- **MySQL Enhancements**: Improved MySQL database management functions.
- **File Handling Updates**: Enhanced operations for CSV, text, and binary file management.
- **System Utilities**: Added support for checking Python interpreter path and processor details.
- **XAMPP Functions**: Added functions for managing XAMPP MySQL and Apache services, and checking PHPMyAdmin accessibility.

## Bug Fixes
- **Error Handling**: Enhanced error handling across file operations and database interactions.
  
## Installation

To install **ncert_learn**, use `pip`:

```bash
pip install ncert_learn

